/*
 * HFRegChk - HotFix Registry Check Tool
 * Version 1.0
 *
 * Copyright  2002 Steffen Lange (Steffen-Lange.com)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#define WIN32_LEAN_AND_MEAN

#include <stdlib.h>
#include <string.h>
#include <windows.h>

#define BUFFER_LENGTH 1024

/**
 * Query Registry for information about Hotfix installation
 * @param argc Set first parameter on command line
 * @param argv[1] Question or Knowledge Base ID
 * @return int 1 = Hotfix installed, 0 = Hotfix not installed OR error occurred
 */
int main(int argc, char *argv[]) {
	char szKey[BUFFER_LENGTH + 1] = {"SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\HotFix\\"};
	char *szValue = {"Installed"};
	HKEY hKey;
	DWORD dwValue = 0;
	DWORD dwSize = sizeof(DWORD);
	DWORD dwType = 0;

	if (argc == 2) {
		strncat(szKey, argv[1], (BUFFER_LENGTH - strlen(szKey)));
		if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, szKey, 0, KEY_READ, &hKey) == ERROR_SUCCESS) {
			if (RegQueryValueEx(hKey, szValue, NULL, &dwType, NULL, NULL) == ERROR_SUCCESS) {
				if (dwType == REG_DWORD) {
					RegQueryValueEx(hKey, szValue, NULL, NULL, &dwValue, &dwSize);
				}
			}
			RegCloseKey(hKey);
		}
	}

	return (dwValue != 1) ? EXIT_SUCCESS : EXIT_FAILURE;
}
